/*******************************************************************************
 Program:  My-Edit
 File:     InpAddrs.c
 Author:   rss
 Date:     08.12.02 
*******************************************************************************/

#include <stdrom.h>
#include <define.h>
#include <libc.h>
#include "input.h"

/**    4   -   INTEGER(2) **/
int Hex2Int(char *str)
{
   byte i, n;
   int Res = 0;
   for (i=0; i < 4; i++) {
      n = str[i];
      if ((n < '0')||(n > 'F')||
         ((n > '9')&&(n < 'A'))) n = 0;
      if (n == 0) break;
      if (n > '9') n -= 7;
      Res = (Res << 4) + (n - '0');
   }
   return(Res);
}

/**  INTEGER(2) -     4   0x00 **/
void Int2Hex4(int nnn, char *str)
{
   int i, n;
   for (i=3; i >= 0; i--) {
      n = (nnn & 15) + '0';
      if (n > '9') n += 7;
      str[i] = n;
      nnn >>= 4;
   }
   str[4] = 0;
}

#define  OBJ_INPADDR  0x9090   // -  

#define  OBJ_RBUTT1  0x9091   // -  RadioButton
#define  OBJ_RBUTT2  0x9092   // -  RadioButton
#define  OBJ_INPSEG  0x9093   // -   SEG-
#define  OBJ_INPOFS  0x9094   // -   OFS-
#define  OBJ_INPFLH  0x9095   // -   FLASH-

TCHTBL far TchRadioButton2[] = {
        30, 73, 70, 80,
        ACT_ICON,  OBJ_RBUTT1,
        0x0000,

        90, 73, 130, 80,
        ACT_ICON,  OBJ_RBUTT2,
        0x0000,

        0,0,0,0,
        ACT_NONE, OBJ_END,
        0x0000
};

TCHTBL far TchAddrInputSeg[] = {
        34, 59, 58, 67,
        ACT_TXTAREA,  OBJ_INPSEG,
        0x0000,

        0,0,0,0,
        ACT_NONE, OBJ_END,
        0x0000
};

TCHTBL far TchAddrInputOfs[] = {
        65, 59, 89, 67,
        ACT_TXTAREA,  OBJ_INPOFS,
        0x0000,

        0,0,0,0,
        ACT_NONE, OBJ_END,
        0x0000
};

//    3-     ,
//        .

/*  4-    */

   char  s_Hex4[5];       //    - 4 .
   byte  mode;            //   ,   -  .
/*       :
   mode = 0 -   ESC,
   mode = 1 -      1,
   mode = 2 -      2,
   mode = 3 -      3,
   mode = 4 -       Enter  NEXT.
*/

void InputHex4(int xx, int yy)
{
  char sbuf[5];
  bool inp_end;
  byte key_c, key_hex;

    telgd[0] = 0xffff;
    strcpy(sbuf, s_Hex4);
    sbuf[4] = 0;

inp_tp.st_x   = xx;           /* Start coordinate (X) of text display */
inp_tp.st_y   = yy;           /* Start coordinate (Y) of text display */
inp_tp.ed_x   = xx + 25;      /* End coordinate (X) of text display */
inp_tp.it_y   = 9;            /* Text display line spacing (Y) */
inp_tp.MAXGYO = 1;            /* Number of text display lines */
inp_tp.font   = IB_CG57FONT;  /* Display font type */

inp_tp.csen   = TRUE;
inp_tp.rtnen  = HALF;         /* =02 -   1  */
inp_tp.maxmj  = 4;
inp_tp.txbf   = sbuf;
inp_tp.gdcmt  = telgd;
inp_tp.txtobj = OBJ_INPADDR;  //   - 9  25, 4 
inp_tp.sbrobj = NULL;         //  
inp_tp.tchtb  = Inp_Tch;
inp_tp.s_pos  = NULL; // &ComScr;

    LibTxtInit(&inp_tp);        /* Initialization of text input */

    LibTchStackClr();
    LibTchStackPush(NULL);
    LibTxtTchSet(&inp_tp);
    LibTchStackPush(TchHardIcon);
    LibTchStackPush(TchModeIcon);  //    ""
    LibTchStackPush(TchRadioButton2);                 // -.
//   ,        
//         (  -   ),
//    -     
//     (   ).
    if (mode == 1) LibTchStackPush(TchAddrInputOfs);  // . . 
    if (mode == 2) LibTchStackPush(TchAddrInputSeg);  // . . 
//    if (mode == 3) ;    //    FLASH .  
    LibTchInit();

    LibDispKey();
    LibPutDisp();
    //        
    //      LAT, CAPS  OVERWRITE...

    inp_end = FALSE;
    while ( !inp_end )
    {
       if (LibTxtDsp(&inp_tp) == TRUE)
          LibPutDisp();

       key_c = LibGetKeyM(&tsts);

       if (key_c == KEY_NONE) {     /*    */
          switch (tsts.obj) {
             case OBJ_HIC_ESC:      //   ESC
                mode = 0;
                inp_end = TRUE;
                break;

             case OBJ_HIC_MBAR:     //   MenuBar
//                LibEditPullDown();
                break;

             case OBJ_RBUTT1:
//                LibPutMsgDlg3("R-Butt 1");   -  -.
                if (mode == 3) {   //    
                   mode = 1;
                   inp_end = TRUE;
                }
                break;

             case OBJ_RBUTT2:
//                LibPutMsgDlg3("R-Butt 2");   -  -.
                if (mode != 3) {   //    
                   mode = 3;
                   inp_end = TRUE;
                }
                break;

             case OBJ_INPOFS:                 
//                LibPutMsgDlg3("OBJ_INP OffSet");    -   .
                if (mode == 1) {   //     
                   mode = 2;
                   inp_end = TRUE;
                }
                break;

             case OBJ_INPSEG:
//                LibPutMsgDlg3("OBJ_INP SEGment");    -   .
                if (mode == 2) {   //     
                   mode = 1;
                   inp_end = TRUE;
                }
                break;
           }
       }

       //   NEXT  ENTER -    
       if ((key_c == KEY_NEXT) || (key_c == KEY_RTN))
       {
          strcpy(s_Hex4, sbuf);
          mode = 4;
          inp_end = TRUE;
       }

       //       
       if (inp_end == FALSE) {
          //   -   ("  ")
          key_hex = KEY_NONE;
          //   -  ,  -  
          if ((key_c == 0) || (key_c >= 208)) key_hex = key_c;
          if ((key_c >= '0')&&(key_c <= '9')) key_hex = key_c;
          if ((key_c >= 'A')&&(key_c <= 'F')) key_hex = key_c;
          if ((key_c >= 'a')&&(key_c <= 'f')) key_hex = key_c - 32;
          if ((key_c >= '')&&(key_c <= '')) key_c -= 33;
          if (key_c == '') key_hex = 'A';
          if (key_c == '') key_hex = 'B';
          if (key_c == '') key_hex = 'B';
          if (key_c == '') key_hex = 'C';
          if (key_c == '') key_hex = 'D';
          if (key_c == '') key_hex = 'E';
          if (key_c == '') key_hex = 'F';
          key_c = key_hex;
       }
       //      INSERT   OVERWRITE ???
       LibTxtInp(key_c, &tsts, &inp_tp);
    }
    LibTchStackClr();
}

/*  ,    3 -,
         (-),
     3    -   ,
       .
*/

   word  Addr1, Addr2, Addr3;      //  

/*    128  48,    
     3  4-  :
              FLASH.
     ,    
      NEXT  ENTER ( /    4).
       .
*/

   byte far scrBuff[1024];     //      .

void InputAddress(char *title)
{
  int b1;
  char a1[6], a2[6], a3[6], a12[10];

    /*       */
    LibGetGraph(16,38, 128,48, &scrBuff[4]);
//       :
//    scrBuff[0] = 128;
//    scrBuff[1] = 0;
//    scrBuff[2] = 48;
//    scrBuff[3] = 0;
    *(word far *)(&scrBuff[0]) = 128;
    *(word far *)(&scrBuff[2]) = 48;


    LibPutFarData(16, 38, 134);       //  128 x 48 - Y = 38..86.
    LibPutProStr(IB_PFONT1, 32, 43, title, 100);
//    LibPutFarData(30, 73, 12);        //  Radio-button
    LibPutProStr(IB_PFONT1, 40, 74, "CPU-addr", 48);
//    LibPutFarData(90, 73, 12);        //  Radio-button
    LibPutProStr(IB_CG57FONT, 100, 74, "FLASH", 42);

    //     -    .
//    mode = 1;            // -   1  -  
//    mode = 2;            // -   2  -  
    mode = 3;            // -   3  - FLASH-
    do {
       b1 = 12;                           //  _ 
       if (mode == 3)  b1 = 42;           //  _ 
       LibPutFarData(30, 73, b1);         //  Radio-button
       LibPutFarData(90, 73, b1+1);       //  Radio-button - 
       Int2Hex4(Addr1, a1);
       Int2Hex4(Addr2, a2);
       Int2Hex4(Addr3, a3);
       switch (mode) {
          case 1:                  //   1-  -  .
             strcpy(a12, ":");       //  
             strcat(a12, a2);        //    
             LibPutProStr(IB_CG57FONT, 59, 59, a12, 31);
             LibPutProStr(IB_CG57FONT, 100, 59, a3, 25);   //  
             strcpy(s_Hex4, a1);     
             InputHex4(34, 59);
             if (mode == 4) Addr1 = Hex2Int(s_Hex4);
             break;
          case 2:                  //   2-  -  .
             strcpy(a12, a1);
             strcat(a12, ":");       //     
             LibPutProStr(IB_CG57FONT, 34, 59, a12, 31);
             LibPutProStr(IB_CG57FONT, 100, 59, a3, 25);   //  
             strcpy(s_Hex4, a2);
             InputHex4(65, 59);
             if (mode == 4) Addr2 = Hex2Int(s_Hex4);
             break;
          case 3:                  //   3-  -  FLASH.
             strcpy(a12, a1);
             strcat(a12, ":");     //   ,    
             strcat(a12, a2);
             LibPutProStr(IB_CG57FONT, 34, 59, a12, 55);
             strcpy(s_Hex4, a3);
             InputHex4(100, 59);
             if (mode == 4) Addr3 = Hex2Int(s_Hex4);
             break;
       }
       if (mode == 0) break;    //    ESC -  
    } while (mode != 4);
    /*        */
    LibPutGraph(16,38, scrBuff);
}
