#include  <stdrom.h>
#include  "define.h"
#include  "libc.h"

//#define  OBJ_TXTTCH  0x9002  -     DEFINE.H (SDK).
#define  OBJ_STRING  0x9003   // -     
#define  OBJ_IC_SET  0x9004   // -   "SET"
#define  OBJ_IC_CLR  0x9005   // -   "CLR"

//  ""  "SET"  "CLR"   .
//  SDK     - ,   .

TCHTBL far TchHeaderIcon[] = {
        71, 0, 98, 11,
        ACT_ICON,  OBJ_IC_CLR,
        0x0000,

        99, 0, 127, 11,
        ACT_ICON,  OBJ_IC_SET,
        0x0000,

        0,0,0,0,
        ACT_NONE, OBJ_END,
        0x0000
};

T_ICON far TIconSet = { &TchHeaderIcon[0], NULL, NULL, 0x00 };
T_ICON far TIconClr = { &TchHeaderIcon[1], NULL, NULL, 0x00 };

/*        */

    TXTP      inp_tp;
    TCHSTS    tsts;
    word      telgd[1];
    TCHTBL    Inp_Tch[3];
    T_SCR_POS Inp_Scb;

/******************************************************************************
*  void InputStr  -    19   .
*  (char *title, char *text, int yy) - ,  , ..
*  [Return] -    None (   BOOL     ESC).
*******************************************************************************/

void InputStr(char *title, char *text, int yy)
{
  char strbuf[20];        //   
  bool input_end;         //     
  byte key_c;             //   
  int  xx;

/*    strbuf[0] = 0; */
    strcpy(strbuf, text);  //    .
    strbuf[19] = 0;        //   .

    LibClrBox(1, yy, 158, 10);
    xx = LibGetProStrSize(IB_CG57FONT, title);
    LibPutProStr(IB_CG57FONT, 3, yy, title, xx);

    telgd[0] = 0xffff;    //   .
    
inp_tp.st_x   = xx + 4;       /* Start coordinate (X) of text display */
inp_tp.st_y   = yy;           /* Start coordinate (Y) of text display */
inp_tp.ed_x   = 158;          /* End coordinate (X) of text display */
inp_tp.it_y   = 9;            /* Text display line spacing (Y) */
inp_tp.MAXGYO = 1;            /* Number of text display lines */
inp_tp.font   = IB_PFONT1;    /* Display font type */

inp_tp.csen   = TRUE;
inp_tp.rtnen  = HALF;         /* =02 -   1  */
inp_tp.maxmj  = 19;
inp_tp.txbf   = strbuf;
inp_tp.gdcmt  = telgd;
inp_tp.txtobj = OBJ_STRING;
inp_tp.sbrobj = NULL;         //  
inp_tp.tchtb  = Inp_Tch;
inp_tp.s_pos  = NULL; //&ComScr;

    LibTxtInit(&inp_tp);        /* Initialization of text input */

    LibTchStackClr();
    LibTchStackPush(NULL);
    LibTxtTchSet(&inp_tp);
    LibTchStackPush(TchHardIcon);
    LibTchStackPush(TchModeIcon);  //    ""
    LibTchInit();

    LibDispKey();
//    LibPutDisp();

    input_end = FALSE;
    while( !input_end )
    {
        if (LibTxtDsp(&inp_tp))
            LibPutDisp();

        key_c = LibGetKeyM(&tsts);
        if (key_c == KEY_NONE) {     /*    */
            switch (tsts.obj) {
            case OBJ_HIC_ESC:      //     ESC.
                input_end = TRUE;
                break;

            case OBJ_HIC_MBAR:     //   MenuBar.
//               LibPutMsgDlg2("MENU BAR icon pressed\r\r   OK!!");
//               LibEditPullDown();
                break;

//            case OBJ_STRING:       //    .
//                LibPutMsgDlg2("String area pressed");
//                break;
           }
        }

        if (key_c == KEY_RTN)    /*  "Enter" - */
        {
        /*    -   "Enter" */
            LibPutMsgDlg2("Enter key pressed");
        }
        if (key_c == KEY_NEXT)   /*  "Next" -   */
        {
            strcpy(text, strbuf);    //    .
            input_end = TRUE;
        }
        LibTxtInp(key_c, &tsts, &inp_tp);
    }
    /*    ESC    . */
    LibTchStackClr();
    /*      . */
}

/******************************************************************************
*  void InputText  -      "MEMO".
*  (char *text, int yy, int nlin) -  , .,  .
*  [Return] -    None.
*******************************************************************************/

void InputText(char *text, int yy, int nlin)
{
  char  texbuf[120];
  bool  input_end;
  byte  key_c;

/*    texbuf[0] = 0; */
    strcpy(texbuf, text);  //    .
    /*        119 !!! */
    texbuf[119] = 0;       //   .

    LibClrBox(1, yy, 158, 9*nlin+1); //     .
    LibPutFarData(2, yy, 286);       // 8x11, x = 2..12 -  

    telgd[0] = 0xffff;    //   
    
 inp_tp.st_x   = 15;           /* Start coordinate (X) of text display */
 inp_tp.st_y   = yy;           /* Start coordinate (Y) of text display */
 inp_tp.ed_x   = 146;          /* End coordinate (X) of text display */
 inp_tp.it_y   = 9;            /* Text display line spacing (Y) */
 inp_tp.MAXGYO = nlin;         /* Number of text display lines */
 inp_tp.font   = IB_PFONT1;    /* Display font type */

 inp_tp.csen   = TRUE;
 inp_tp.rtnen  = TRUE;         /* =01 -      */
 inp_tp.maxmj  = 80;           //    80 .
 inp_tp.txbf   = texbuf;
 inp_tp.gdcmt  = telgd;
 inp_tp.txtobj = OBJ_TXTTCH;
 inp_tp.sbrobj = OBJ_SCR_BAR;   // x = 148..157 -  .
 inp_tp.tchtb  = Inp_Tch;
 inp_tp.s_pos  = &Inp_Scb;

    LibTxtInit(&inp_tp);        /* Initialization of text input */

    LibTchStackClr();
    LibTchStackPush(NULL);
    LibTxtTchSet(&inp_tp);
    LibTchStackPush(TchHardIcon);
    LibTchStackPush(TchModeIcon);  //    "".
    LibTchInit();

    LibDispKey();
//    LibPutDisp();

    input_end = FALSE;
    while( !input_end )
    {
        if (LibTxtDsp(&inp_tp))
            LibPutDisp();

        key_c = LibGetKeyM(&tsts);
        if (key_c == KEY_NONE) {     /*    */
            switch (tsts.obj) {
            case OBJ_HIC_ESC:      //     ESC.
                input_end = TRUE;
                break;

            case OBJ_HIC_MBAR:     //   MenuBar
//               LibPutMsgDlg2("MENU BAR pressed\r\r   OK!!");
//               LibEditPullDown();
                break;
           }
        }
        //  "Enter"       .

        if (key_c == KEY_NEXT)     //     NEXT.
        {
            strcpy(text, texbuf);
            input_end = TRUE;
        }
        LibTxtInp(key_c, &tsts, &inp_tp);
    }
    LibTchStackClr();
}

/****** -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=- *****/
/***********      *************/
/*   -      . */

void CalcBuf2Str(char *str, byte *cbuf)
{    /* Calculator X-buffer -->  string buffer */
  int  ii, nn, tt;

    tt = 13 - cbuf[0];  /*      */
    nn = 0;
    if (cbuf[1] == 0x0C) str[nn++] = '-';  /*     */
    if (cbuf[1] == 0x04) str[nn++] = '+';

    for (ii=13; ii >= 2; ii--)
    {
       if (cbuf[ii] > 0x20) str[nn++] = cbuf[ii];
       if (ii == tt) str[nn++] = '.';
    };
//    if (str[nn-1] == '.') nn--;   /*       */
    str[nn] = 0;      /*      */
}

/*************   -    ******************/

  CALWRAM  Calram;       //   -  .

/******************************************************************************
*  void InputCalc  -      .
*  (char *title, char *text, int yy) - ,  , ..
*  [Return] -    None.
*******************************************************************************/

void InputCalc(char *title, char *text, int yy)
{
  char tbuf[16];
  bool input_end;
  int  xx;

//    tbuf[0] = 0;
    strcpy(tbuf, text);      //     
//       tbuf   calxbuf.

    LibClrBox(1, yy, 158, 10);
    xx = LibGetProStrSize(IB_CG57FONT, title);
    LibPutProStr(IB_CG57FONT, 3, yy, title, xx);

    LibTchStackClr();
    LibTchStackPush(NULL);
    LibTchStackPush(TchHardIcon);
    LibTchStackPush(TchModeIcon);  //    ""
    LibTchInit();

    LibCalKeyInit(&Calram);
//         
//    Set_CalcBuf(Calram.calxbuf, tbuf);
    LibCalKeyDsp(&Calram);
//    LibPutDisp();

    input_end = FALSE;
    while( !input_end )
    {
        LibPutDisp();
        LibCalKeyTchWait(&Calram, &tsts); /* Waits for touch of calculator */
        /*    "Next"  "="      */

        switch(tsts.obj) {
        case OBJ_CAL_EQUAL: {   /* "=" -  "" */
            CalcBuf2Str(tbuf, Calram.calxbuf);    //  .
            break;
            }
        case OBJ_CAL_NEXT: {    /*  "Next" */
            CalcBuf2Str(tbuf, Calram.calxbuf);    //  ,
            strcpy(text, tbuf);                   //    /,
            input_end = TRUE;                     //   .
            break;
            }

        case OBJ_HIC_ESC:
//            LibPutMsgDlg2("ESC pressed\r\rOK!!");
            input_end = TRUE;    //     
            break;

        case OBJ_HIC_MBAR:
//            LibPutMsgDlg2("MENU BAR pressed\r\r   OK!!");
            strcpy(tbuf, "MENU BAR - OK!");
            break;
        }
/*        "Next"  "="     
                 .
          "Next"       /.
          "Next"  "ESC"    .
*/
        LibClrBox(xx + 4, yy, 80, 10);
        LibPutProStr(IB_CG57FONT, xx + 4, yy, tbuf, 80);
    }
    LibTchStackClr();
}
/****** -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=- *****/

