/******************************************************************************
   [Title]         Program     
******************************************************************************/
#include  <stdrom.h>
#include  "define.h"
#include  "libc.h"
//#include  "stdio.h"
//#include  "l_define.h"
//#include  "l_libc.h"
/****************************************************************************/
#include  "input.h"
#include  "InpHexkb.h"
#include  "InpAddrs.h"

    static char ProgTitle[] = "INPUT- 3";   /* Program name */

    char sname[20] = "EditName - 12345";
    char numb[16]  = "1000";
    char stext[120];
    byte jdate[8]  = "20040301";

#ifdef _P_FAR
void main(void)              //  P-Model
#else
void far main(void)          //  S-Model
#endif
{
//    int  i, j;
    char digit[8];
    int nn;

    LibClrDisp();
    LibPutFarData(0, 0, 23);
    LibPutProStr(IB_PFONT3, 14, 1, ProgTitle, 80);
    LibModeIconDsp();               //   ""
    LibBox(0, 13, 160, 75, 1);

//    LibPut35Str(5, 30, "3226 / 3416");   //   35//

    stext[0] = 0;

    Addr1 = 0x2000;      //*** global variables in module InpAddrs.c ***/
    Addr2 = 0x0100;
    Addr3 = 0;

// -----------

    /***       . ***/
    while(1) {
        // P.1. - Input single string 20 characters.
        InputStr(" :", sname, 16);
        LibClrBox(1, 16, 158, 10);
        LibPutProStr(IB_PFONT1, 4, 16, "1 - ", 56);
        LibPutProStr(IB_PFONT2, 60, 16, sname, 98);
// LibPutDisp() -        .

        // P.2. - Input multiline text.
        InputText(stext, 26, 4);
        LibClrBox(14, 26, 145, 9*4+1);     //    - .
        // 2    :
        LibPutProStr(IB_PFONT2, 15, 26, stext, 144);
        LibStringDsp(stext, 15, 36, 158, IB_PFONT2);
        /*       ... */
        //   -    ...

        // P.3. - Input number string from calculator keyboard.
        // K ,  -   .
        InputCalc(" :", numb, 48);
        LibClrBox(1, 48, 158, 10);
        LibPutProStr(IB_PFONT1, 4, 48, " -", 56);
        //    numb        .
        LibPutProStr(IB_PFONT2, 60, 48, numb, 98);
        //      longint  float,   .
        nn = atoi(numb);
        itoa(nn, digit, 10);
        LibPutProStr(IB_PFONT2, 120, 48, digit, 38);

        // P.4. - Input hexidecimal number as string.
        // C   HEX- (  ).
        InputHexKeyb(" HEX-kb:", numb, 58);
        LibClrBox(1, 58, 158, 10);
        LibPutProStr(IB_PFONT1, 4, 58, "Hex- -", 60);
        //    numb      .
        LibPutProStr(IB_PFONT2, 65, 58, numb, 98);
        //      longint64 (??),   .

        // P.5. - Input three 4-digits hexidecimal address.
        //   3-  WORD  HEX-.
        Addr3 = Hex2Int(numb);            //      numb.
        InputAddress(" hex-:");
        LibClrBox(1, 68, 158, 10);
        LibPutProStr(IB_PFONT1, 4, 68, "Hex- -", 64);
        Int2Hex4(Addr1, digit);
        LibPutProStr(IB_PFONT2, 70, 68, digit, 30);
        Int2Hex4(Addr2, digit);
        LibPutProStr(IB_PFONT2, 100, 68, digit, 30);
        Int2Hex4(Addr3, digit);
        LibPutProStr(IB_PFONT2, 130, 68, digit, 28);
 //        LibPutDisp();

        // P.6. - Input Date using the Calendar keyboard.
        //       .
//        LibPutProStr(IB_CG57FONT, 3, 58, " : ", 60); -  .
        LibJumpDate(jdate);       //   ,  .

        LibClrBox(1, 78, 158, 9);
        LibPutProStr(IB_PFONT1, 4, 78, " -", 55);
        LibDateDisp(jdate, WEEK_ON, 50, 78, 156, DISP_MODE, IB_PFONT2);

//        LibPutDisp();    -       .

      /*   -       ... */

    };
    LibJumpMenu();  //  ,     
}

